
/*--------------------------------------
; http://www.setsuki.com/
-------------------------------------*/

#include "kernel32.as"
#include "ole32.as"

#ifdef __hsp30__
#ifndef __GDI32__
#define global __GDI32__
#uselib "GDI32.DLL"
	#func global SetDIBits "SetDIBits" sptr,sptr,sptr,sptr,sptr,sptr,sptr
	#func global GetDIBits "GetDIBits" sptr,sptr,sptr,sptr,sptr,sptr,sptr
#endif
#endif

#define globalGMEM_MOVEABLE   2

;enum Unit
#enum global UnitWorld = 0	// 0 -- World coordinate (non-physical unit)
#enum global UnitDisplay	// 1 -- Variable -- for PageTransform only
#enum global UnitPixel	// 2 -- Each unit is one device pixel.

#undef picload

#module
;---------- --------- ---------- ---------- ----------
#uselib "gdiplus"
	#func GdiplusStartup	"GdiplusStartup"	int, int, int
	#func GdiplusShutdown	"GdiplusShutdown"	int
	#func GdipLoadImageFromStream "GdipLoadImageFromStream" int, int
	#func GdipCreateFromHDC		"GdipCreateFromHDC"	int, int
	#func GdipCreateImageAttributes         "GdipCreateImageAttributes" int
	#func GdipSetImageAttributesColorMatrix "GdipSetImageAttributesColorMatrix" int, int, int, int, nullptr, nullptr
	#func GdipDeleteGraphics	"GdipDeleteGraphics"	int
	#func GdipDisposeImage		"GdipDisposeImage"	int
	#func GdipGetImageWidth		"GdipGetImageWidth"	int, int
	#func GdipGetImageHeight	"GdipGetImageHeight"	int, int
	#func GdipGetImagePixelFormat     "GdipGetImagePixelFormat" int, int
	#func GdipDrawImageRectRectI	"GdipDrawImageRectRectI"	int, int, int, int, int, int, int, int, int, int, int, int, int, int
	#func GdipSetSmoothingMode	"GdipSetSmoothingMode"	int, int
	#func GdipSetPixelOffsetMode	"GdipSetPixelOffsetMode"	int, int
	#func GdipSetCompositingQuality	"GdipSetCompositingQuality"	int, int
	#func GdipSetTextRenderingHint	"GdipSetTextRenderingHint"	int, int

;--------------------------------------
; 摜t@C[h
;--------------------------------------
#deffunc picload var buf, int off, int size
mref bm, 67

	; [Xg[ǂݍ
	GlobalAlloc GMEM_MOVEABLE, size : if( stat == 0 ): return
	hMemory = stat : GlobalLock hMemory
	dupptr tmpmem, stat, size, 2
	memcpy tmpmem, buf, size, 0, off : dim tmpmem, 1
	GlobalUnlock hMemory
	CreateStreamOnHGlobal hMemory, 1, varptr(pIStream)
	if( stat ){
		GlobalFree hMemory : hMemory = 0 : return
	}
	gsi = 1, 0, 0, 0
	GdiplusStartup varptr(gdiplusToken), varptr(gsi), 0	; GDI+ Jn

	GdipLoadImageFromStream pIStream, varptr(imgImage)
	if( imgImage ){
		GdipGetImageWidth  imgImage, varptr(gsi.0)
		GdipGetImageHeight imgImage, varptr(gsi.1)
		GdipGetImagePixelFormat imgImage, varptr(gsi.2)

		GdipCreateFromHDC hdc, varptr(tmpGraphics)
		if( bm.33 > 32 )&&( bm.34 > 32 ){
			GdipDrawImageRectRectI tmpGraphics, imgImage, ginfo_cx,ginfo_cy, bm.33, bm.34, 0,0, gsi.0, gsi.1, UnitPixel,0,0
		} else {
			GdipDrawImageRectRectI tmpGraphics, imgImage, ginfo_cx,ginfo_cy, gsi.0, gsi.1, 0,0, gsi.0, gsi.1, UnitPixel,0,0
		}
		GdipDeleteGraphics tmpGraphics

		GdipDisposeImage tmpImage : imgImage = 0 ; Image 
	}
	if( hMemory ){
		ReleaseStgMedium varptr(pIStream)
		GlobalFree hMemory : hMemory = 0
	}
	GdiplusShutdown gdiplusToken : gdiplusToken = 0 ; GDI+ I
	
	redraw 1
	return

;--------------------------------------
#global

